﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

using Tsukikage.GameSDK.GSystem;
using Tsukikage.GameSDK.Direct3D;
using Tsukikage.GameSDK.DirectSound;
using Tsukikage.GameSDK.TaskSystem;
using Tsukikage.GameSDK.TaskSystem.Library;
using Tsukikage.GameSDK.Base;

using Kuzushi.Resources;

namespace Kuzushi.Scenes
{
    /// <summary>
    /// シーン
    /// </summary>
    public class Start : Scene
    {
        /// <summary>
        /// ハイスコア
        /// </summary>
        int highScore = 0;

        /// <summary>
        /// シーン初期化時。
        /// </summary>
        public override void Initialize()
        {
            // Texturesクラスに定義されているD3DTextureを、
            // GSDK.D3Dのインスタンスですべて読み込む。以下同様。
            StaticResourceLoader.LoadTextures(typeof(Textures));
            StaticResourceLoader.LoadFonts(typeof(Fonts));
            StaticResourceLoader.LoadMusic(typeof(Music));
            StaticResourceLoader.LoadSounds(typeof(Sounds));

            Music.BGM1.Play();
        }

        Engine.Engine engine = new Kuzushi.Engine.Engine();

        /// <summary>
        /// シーン内部処理。
        /// </summary>
        public override void Internal()
        {
            if (GSDK.DInput.ButtonsState[4].Pushed)
            {
                this.highScore = engine.highScore;
                engine = new Kuzushi.Engine.Engine();
                engine.highScore = this.highScore;
            }

            engine.Internal();
        }

        /// <summary>
        /// シーン描画処理。
        /// </summary>
        public override void Draw()
        {
            engine.Draw();
        }

        /// <summary>
        /// シーンで使用したリソースを解放する。
        /// </summary>
        protected override void Release()
        {
        }
    }
}